

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>wfGenes &mdash; wfGenes  documentation</title>
  

  
  <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    
    <script type="text/javascript" src="_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="#" class="icon icon-home"> wfGenes
          

          
            
            <img src="_static/wfgenes_logo.png" class="logo" alt="Logo"/>
          
          </a>

          
            
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <!-- Local TOC -->
              <div class="local-toc"><ul>
<li><a class="reference internal" href="#">wfGenes</a></li>
<li><a class="reference internal" href="#how-it-works">How it works</a></li>
<li><a class="reference internal" href="#wfgeneslab">wfGenesLab</a></li>
<li><a class="reference internal" href="#installation-and-setup">Installation and Setup</a></li>
<li><a class="reference internal" href="#hands-on">Hands-on</a></li>
<li><a class="reference internal" href="#contacts">Contacts</a></li>
<li><a class="reference internal" href="#legal-notice">Legal Notice</a></li>
</ul>
</div>
            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="#">wfGenes</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="#" class="icon icon-home"></a> &raquo;</li>
        
      <li>wfGenes</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="_sources/index.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <span class="target" id="wfgenes"></span><div class="section" id="id1">
<h1>wfGenes<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h1>
<p>wfGenes (workflow generator) is a tool to generate various type of workflow management systems (WMSs) by parsing single workflow configuration file called WConfig.
Naturally, within wfGenes framework, workflows are defined in human readable formats, JSON or YAML, with efficient and concise structure to generate different type of WMSs by performing dependency analysis and automatic code generation for specific WMS.
This approach enables users to examine different type of WMS based on the application requirement and available computing environment.
Here we demonstrate the wfGenes capability by constructing four different WMSs using WConfig (configuration file) and wfGenes. Following lines briefly introduce these tools and summarize their main feature in the table below. For more information about these systems and their potentials refer to hyperlinks.</p>
<blockquote>
<div><ol class="arabic simple">
<li><p><a class="reference external" href="https://materialsproject.github.io/fireworks/">FireWorks</a> is an Open source WMS with well separated data and computation phase using Mongodb to enable workflow managements for distributed workers across single or multiple cluster(s) while offering srtrong query mechansim thanks to stranog database backend.</p></li>
<li><p><a class="reference external" href="https://www.simstack.de/">SimStack</a> is a commercial tool featured with Graphical User Interface (GUI) with available set of customizable blocks (IPs) deployed in nano material simulation domain.</p></li>
<li><p><a class="reference external" href="https://dask.org/">Dask</a> is an open source library for parallel python computing. With various parallel array data types built on top of Numpy and Pandas arrays, Dask is suitable for memory intensive computation with the capability to scale on many nodes. Dask builtin task scheduler coordinates execution sequence between tasks and exploit parallelism in a lazy manner. This enable users to generate their task graph prior to simulation with minimum amount of code modification.</p></li>
<li><p><a class="reference external" href="https://parsl-project.org/">Parsl</a> is a parallel python libraries to scale python scripts across many cores. With various kind of executors, Parsl enable users to accelerate their applications and achieve extreme scalability using Parsl specific syntax and decorators.</p></li>
</ol>
</div></blockquote>
<p>All discussed tools are able to scale applications from personal laptops to super computers.</p>
<table class="colwidths-given docutils align-default" id="id2">
<caption><span class="caption-text">Overview of supported WMS by wfGenes</span><a class="headerlink" href="#id2" title="Permalink to this table">¶</a></caption>
<colgroup>
<col style="width: 1%" />
<col style="width: 1%" />
<col style="width: 1%" />
<col style="width: 1%" />
<col style="width: 95%" />
<col style="width: 1%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>WMS</p></th>
<th class="head"><p>Input Language</p></th>
<th class="head"><p>GUI</p></th>
<th class="head"><p>Post-Processing</p></th>
<th class="head"><p>Fault tolerance</p></th>
<th class="head"><p>License</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>FireWorks</p></td>
<td><p>YAML/JSON/Python</p></td>
<td><p>No</p></td>
<td><p>Monitoring/Database Query</p></td>
<td><p>Relaunching fizzled subworkflow (fireworks)</p></td>
<td><p>BSD</p></td>
</tr>
<tr class="row-odd"><td><p>SimStack</p></td>
<td><p>XML</p></td>
<td><p>Yes</p></td>
<td><p>Monitoring</p></td>
<td><p>Relaunching fizzled subworkflow (WaNos)</p></td>
<td><p>Commercial</p></td>
</tr>
<tr class="row-even"><td><p>Dask</p></td>
<td><p>Python</p></td>
<td><p>No</p></td>
<td><p>Monitoring</p></td>
<td><p>none</p></td>
<td><p>BSD</p></td>
</tr>
<tr class="row-odd"><td><p>Parsl</p></td>
<td><p>Python</p></td>
<td><p>No</p></td>
<td><p>Monitoring</p></td>
<td><p>Lazy failure and check-pointing</p></td>
<td><p>Apache</p></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="how-it-works">
<span id="step-0"></span><h1>How it works<a class="headerlink" href="#how-it-works" title="Permalink to this headline">¶</a></h1>
<p>To get started with wfGenes, WConfig should be prepared based on workflow graph. In fact, WConfig is an abstract description of inputs, outputs and function names to be parsed by wfGenes. Apart from configuration file, additional arguments provides controlability over automation process and output generation.</p>
<blockquote>
<div><dl class="option-list">
<dt><kbd><span class="option">--workflowconfig</span></kbd></dt>
<dd><p>Path to workflowconfig file that contains data of workflow in YAML/JSON format. i.e. Input/Outputfile, modules and arguments names, the default is workflow.yaml.</p>
</dd>
<dt><kbd><span class="option">--inputpath</span></kbd></dt>
<dd><p>Set input path of Workflow, the directory to fetch input data.. Default is current working directory.</p>
</dd>
<dt><kbd><span class="option">--wms</span></kbd></dt>
<dd><p>Choose specific workflow manageme system. Possible values are FireWorks, SimStack, Dask and Parsl.</p>
</dd>
</dl>
</div></blockquote>
<p>In the following snippets, two simple workflows are described in YAML format and presents the WConfig structure. During Modeling phase, wfGenes validates user’s input against WConfig schema to ensure successful generation phase.</p>
<div class="highlight-yaml notranslate"><div class="highlight"><pre><span></span><span class="nt">workflow_name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">First workflow</span>
<span class="nt">nodes</span><span class="p">:</span>
<span class="p p-Indicator">-</span> <span class="nt">name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">node_1</span>
  <span class="nt">id</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">1</span>
  <span class="l l-Scalar l-Scalar-Plain">tasks:s</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_1</span> <span class="p p-Indicator">,</span> <span class="nv">module_1</span><span class="p p-Indicator">]</span>
    <span class="nt">input</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output1_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_1</span><span class="p p-Indicator">,</span> <span class="nv">module_2</span><span class="p p-Indicator">]</span>
    <span class="nt">inputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input1</span><span class="p p-Indicator">,</span> <span class="nv">output1_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output2_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
<span class="p p-Indicator">-</span> <span class="nt">name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">node_2</span>
  <span class="nt">id</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">2</span>
  <span class="nt">tasks</span><span class="p">:</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_1</span><span class="p p-Indicator">,</span> <span class="nv">module_3</span><span class="p p-Indicator">]</span>
    <span class="nt">inputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input2</span><span class="p p-Indicator">,</span> <span class="nv">input1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output1_id2</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
<span class="p p-Indicator">-</span> <span class="nt">name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">node_3</span>
  <span class="nt">id</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">3</span>
  <span class="nt">tasks</span><span class="p">:</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_2</span><span class="p p-Indicator">,</span> <span class="nv">module_1</span><span class="p p-Indicator">]</span>
    <span class="nt">inputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output2_id1</span><span class="p p-Indicator">,</span> <span class="nv">output1_id2</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output1_id3</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
</pre></div>
</div>
<div class="highlight-yaml notranslate"><div class="highlight"><pre><span></span><span class="nt">workflow_name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">Second workflow</span>
<span class="nt">nodes</span><span class="p">:</span>
<span class="p p-Indicator">-</span> <span class="nt">name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">node_1</span>
  <span class="nt">id</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">1</span>
  <span class="nt">tasks</span><span class="p">:</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_1</span><span class="p p-Indicator">,</span> <span class="nv">module_1</span><span class="p p-Indicator">]</span>
    <span class="nt">input</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output1_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_1</span><span class="p p-Indicator">,</span> <span class="nv">module_2</span><span class="p p-Indicator">]</span>
    <span class="nt">inputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input2</span><span class="p p-Indicator">,</span> <span class="nv">output1_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output2_id1</span> <span class="p p-Indicator">,</span> <span class="nv">output3_id1</span> <span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
<span class="p p-Indicator">-</span> <span class="nt">name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">node_2</span>
  <span class="nt">id</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">2</span>
  <span class="nt">tasks</span><span class="p">:</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_1</span><span class="p p-Indicator">,</span> <span class="nv">module_3</span><span class="p p-Indicator">]</span>
    <span class="nt">inputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input1</span><span class="p p-Indicator">,</span> <span class="nv">output2_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output1_id2</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
<span class="p p-Indicator">-</span> <span class="nt">name</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">node_3</span>
  <span class="nt">id</span><span class="p">:</span> <span class="l l-Scalar l-Scalar-Plain">3</span>
  <span class="nt">tasks</span><span class="p">:</span>
  <span class="p p-Indicator">-</span> <span class="nt">func</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">source_2</span><span class="p p-Indicator">,</span> <span class="nv">module_1</span><span class="p p-Indicator">]</span>
    <span class="nt">inputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">input1</span><span class="p p-Indicator">,</span> <span class="nv">output3_id1</span><span class="p p-Indicator">]</span>
    <span class="nt">outputs</span><span class="p">:</span> <span class="p p-Indicator">[</span><span class="nv">output1_id3</span><span class="p p-Indicator">]</span>
    <span class="nt">kwargs</span><span class="p">:</span> <span class="p p-Indicator">{}</span>
</pre></div>
</div>
<p>However, wfGenes constructs and adopts workflow based on user preferred WMS, several common consideration are taking to account to ensure the quality of result is not affected by automation process.</p>
<ul class="simple">
<li><p>In a unified fashion, configuration file contain source and module names to pass necessary information to tool for automatic wrapper generation.</p></li>
</ul>
<p>The WGenerator generates executable python wrapper from custom configuration while taking care of three main criteria that boosts performance while preserving functionality:</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>One time load of extra inputs.</p></li>
<li><p>One time import of duplicate modules.</p></li>
<li><p>Resolving dependency in data-flow and optimized code generation.</p></li>
</ol>
</div></blockquote>
<ul class="simple">
<li><p>wfGenes construct task graph by matching names, e.g , in the first workflow, in node one <strong>output1_id1</strong> is passed to next function (local dependency) or , in the second workflow, <strong>output2_id1</strong> is passed to node_3 (global dependency).</p></li>
</ul>
<div class="figure align-center">
<a class="reference internal image-reference" href="_images/wgenerator_first_sample.png"><img alt="wgenerator first sample" src="_images/wgenerator_first_sample.png" style="width: 200px;" /></a>
</div>
<div class="figure align-center" id="id3">
<a class="reference internal image-reference" href="_images/wgenerator_second_sample.png"><img alt="wgenerator second sample" src="_images/wgenerator_second_sample.png" style="width: 200px;" /></a>
<p class="caption"><span class="caption-text">Directed Acyclic Graph (DAG) generated by wfGenes for two different discussed sample</span><a class="headerlink" href="#id3" title="Permalink to this image">¶</a></p>
</div>
<ul class="simple">
<li><p>Regardless of target WMS, generated outputs by wfGenes are validated against schema to assure early stage validation and ease further improvement of the tool.</p></li>
</ul>
<div class="figure align-center">
<a class="reference internal image-reference" href="_images/Wgenerator_tool.png"><img alt="wfGenes" src="_images/Wgenerator_tool.png" style="width: 400px;" /></a>
</div>
</div>
<div class="section" id="wfgeneslab">
<h1>wfGenesLab<a class="headerlink" href="#wfgeneslab" title="Permalink to this headline">¶</a></h1>
<p>wfGenesLab is a widget based user interface for wfGenes that runs on top of JupyterLab. It provides a light-weight and intuitive interface to generate, visualize and execute workflow graphs. wfGenesLab offers a dashboard of Jupyter widgets –various type of buttons and clickable links– to couple modeling phase to execution in a customizable manner using wfGenes under the hood.</p>
<div class="figure align-center" id="id4">
<a class="reference internal image-reference" href="_images/wfGenesLab_interface_3.jpg"><img alt="wfGenes" src="_images/wfGenesLab_interface_3.jpg" style="width: 350px;" /></a>
<p class="caption"><span class="caption-text">The WConfig file and inputpath should be
set before generating target WMS.</span><a class="headerlink" href="#id4" title="Permalink to this image">¶</a></p>
</div>
<div class="figure align-center" id="id5">
<a class="reference internal image-reference" href="_images/wfGenesLab_interface_2.jpg"><img alt="wfGenes" src="_images/wfGenesLab_interface_2.jpg" style="width: 700px;" /></a>
<p class="caption"><span class="caption-text">The wfGenes visualize the task graph from WConfig and produce valid input for specified system. Moreover, the WConfig can be modified interactively using provided link in console.</span><a class="headerlink" href="#id5" title="Permalink to this image">¶</a></p>
</div>
<div class="figure align-center" id="id6">
<a class="reference internal image-reference" href="_images/wfGenesLab_interface_3.jpg"><img alt="wfGenes" src="_images/wfGenesLab_interface_3.jpg" style="width: 651.5px; height: 267.0px;" /></a>
<p class="caption"><span class="caption-text">wfGenesLab executor runs generated python models for Dask and Parsl on two different type of resources 1. Local to be used on personal working stations or 2. Slurm to run the workflow on supercomputers.</span><a class="headerlink" href="#id6" title="Permalink to this image">¶</a></p>
</div>
</div>
<div class="section" id="installation-and-setup">
<h1>Installation and Setup<a class="headerlink" href="#installation-and-setup" title="Permalink to this headline">¶</a></h1>
<p>wfGenes offers conda environment setup that can be installed by issuing the command below:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>conda env create -f wfgenes.yml
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If conda is not installed for your account you can installe <a class="reference external" href="https://docs.conda.io/en/latest/miniconda.html">miniconda</a> locally and use conda package manger, alternatively, if it is provided by administrator you can load conda and resume with wfGenes installation.</p>
</div>
<p>After installation, you should activate wfGenes environment by issuing:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>conda activate wfgenes
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>wfGenes environment setup is tested on different Linux distributions and was able to bring portability across personal laptops and supercomputers while testing hands on examples.</p>
</div>
</div>
<div class="section" id="hands-on">
<h1>Hands-on<a class="headerlink" href="#hands-on" title="Permalink to this headline">¶</a></h1>
<p><a class="reference internal" href="handson.html#handson"><span class="std std-ref">Click Here</span></a></p>
</div>
<div class="section" id="contacts">
<h1>Contacts<a class="headerlink" href="#contacts" title="Permalink to this headline">¶</a></h1>
<p><a class="reference external" href="https://twitter.com/wfgenes">Twitter</a></p>
</div>
<div class="section" id="legal-notice">
<h1>Legal Notice<a class="headerlink" href="#legal-notice" title="Permalink to this headline">¶</a></h1>
<p>The documentation is licensed under an
Attribution-NonCommercial-NoDerivatives 4.0 International
Creative Commons License
<a class="reference external" href="http://creativecommons.org/licenses/by-nc-nd/4.0/">http://creativecommons.org/licenses/by-nc-nd/4.0/</a></p>
<p>Copyright © 2021 Karlsruhe Institute of Technology (KIT)</p>
</div>


           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2020 Karlsruhe Institute of Technology (KIT) .

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>